package de.uni_passau.fim.PADAS.group3.DataDash.controler;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.web.bind.annotation.*;
import de.uni_passau.fim.PADAS.group3.DataDash.model.Dataset;
import de.uni_passau.fim.PADAS.group3.DataDash.model.DatasetService;
import de.uni_passau.fim.PADAS.group3.DataDash.model.Type;
import org.springframework.data.domain.Pageable;
import org.springframework.data.web.config.EnableSpringDataWebSupport;
import org.springframework.data.domain.Sort;

import java.util.UUID;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

@RestController
@RequestMapping("/api/v1/datasets")
@EnableSpringDataWebSupport
public class DatasetController {
    @Autowired
    private DatasetService datasetService;

    // @GetMapping
    // public List<Dataset> getAllDatasets() {
    // return datasetService.getAllDatasets();
    // }

    @GetMapping("/id/{id}")
    public Dataset getDatasetById(@PathVariable("id") UUID id) {
        return datasetService.getDatasetById(id);
    }

    @PostMapping
    public Dataset createDataset(@RequestBody Dataset dataset) {
        datasetService.addDataset(dataset);
        // TODO: figure out what the fuck i need to do here
        return null;
    }

    // @PutMapping("/{id}")
    // public Dataset updateDataset(@PathVariable("id") Long id, @RequestBody
    // Dataset dataset) {
    // return datasetService.updateDataset(id, dataset);
    // }
    //

    @DeleteMapping("/id/{id}")
    public void deleteDataset(@PathVariable("id") UUID id) {
        datasetService.deleteDataset(id);
    }

    @PostMapping("/id/{id}/upvote")
    public Dataset upvote(@PathVariable("id") UUID id) {
        datasetService.upvoteDataset(id);
        return null;
    }

    @PostMapping("/id/{id}/downvote")
    public Dataset downvote(@PathVariable("id") UUID id) {
        datasetService.downvoteDataset(id);
        return null; // new ResponseEntity<>(null, HttpStatus.OK);
    }

    @PostMapping("/id/{id}/vote")
    public String postMethodName(@PathVariable("id") UUID id,
            @RequestParam("stars") int stars) {
        if (stars > 0 && stars < 6) {
            datasetService.voteDataset(id, stars);
            return null;
        }
        return "Invalid vote";
    }

    @GetMapping
    public Page<Dataset> getDatasetsByDateAfter(@RequestParam(value = "author", required = false) String author,
            @RequestParam(value = "title", required = false) String title,
            @RequestParam(value = "description", required = false) String description,
            @RequestParam(value = "abst", required = false) String abst,
            @RequestParam(value = "type", required = false) Type type,
            @RequestParam(value = "min-raiting", required = false) Float raiting,
            @RequestParam(value = "page", required = false, defaultValue = "0") int page,
            @RequestParam(value = "size", required = false, defaultValue = "20") int size,
            @RequestParam(value = "sort", required = false, defaultValue = "upvotes") String sort,
            @RequestParam(value = "direction", required = false, defaultValue = "desc") String direction) {
        Pageable pageable = PageRequest.of(page, size,
                Sort.by(direction.equals("asc") ? Sort.Direction.ASC : Sort.Direction.DESC, sort));
        return datasetService.getDatasetsByOptionalCriteria(title, description, author, abst, type, raiting, pageable);
    }

    @GetMapping("/search")
    public Page<Dataset> search(@RequestParam(value = "search", required = false, defaultValue = "%") String search,
            @RequestParam(value = "page", required = false, defaultValue = "0") int page,
            @RequestParam(value = "size", required = false, defaultValue = "20") int size,
            @RequestParam(value = "sort", required = false, defaultValue = "upvotes") String sort,
            @RequestParam(value = "direction", required = false, defaultValue = "desc") String direction) {
        Pageable pageable = PageRequest.of(page, size,
                Sort.by(direction.equals("asc") ? Sort.Direction.ASC : Sort.Direction.DESC, sort));
        return datasetService.searchByOptionalCriteria(search, pageable);
    }

}